<template>
  <div class="report-hor-bar-chart">

    <div class="report-hor-bar-chart__title-row">
      <div class="report-hor-bar-chart__title-row__position">Posi&shy;ción</div>
      <div class="report-hor-bar-chart__title-row__organization-name">Enti&shy;dades<br>contra&shy;tantes</div>
      <div class="report-hor-bar-chart__title-row__register-number">{{ chartLabels.xAxisLabel }}</div>

    </div>

    <div class="report-hor-bar-chart__content-part">
      <div v-for="(value, key, index) in sortedData" :key="index" class="report-hor-bar-chart__content-part__single-organization-row">
        <div class="report-hor-bar-chart__content-part__single-organization-row__position">{{ index + 1 }}</div>
        <div class="report-hor-bar-chart__content-part__single-organization-row__name-with-bar">
          <div class="report-hor-bar-chart__content-part__single-organization-row__name-with-bar__name">{{ key }}</div>
          <div class="report-hor-bar-chart__content-part__single-organization-row__name-with-bar__bar">
            <div
              :id="`report-${props.indicator}_bar_${index}`"
              class="report-hor-bar-chart__content-part__single-organization-row__name-with-bar__bar__colored-bar"

            />
          </div>
        </div>
        <div class="report-hor-bar-chart__content-part__single-organization-row__register-number">{{ value }}</div>
      </div>
    </div>
  </div>

</template>

<script setup>
import { computed, onMounted } from 'vue';
import getChartLabels from 'src/composables/get_chart_labels';

const props = defineProps({
  data:      { type: Object, required: true },
  indicator: { type: String, required: true },
});

const data = computed(() => {
  return props?.data?.reduce((acc, item) => {
    acc[item.entidad_contratante] = +item.register_number;
    return acc;
  }, {});
});

const calculateBarWidth = (minValue, maxValue, currentValue) => {
  let barWidth = '';

  switch (currentValue) {
    case minValue:
      barWidth = '10%';
      break;

      case maxValue:
        barWidth = '100%';
        break;

        default:
      barWidth = `${(1 - 0.9 * (maxValue - currentValue) / (maxValue - minValue)) * 100}%`;
      break;
  }

  return barWidth;
};

const sortByValues = obj => {
  const sortedEntries = Object.entries(obj).sort(([, a], [, b]) => b - a);
  return Object.fromEntries(sortedEntries);
};

let sortedData = computed(() => sortByValues(data.value));
const minDataValue = computed(() => Math.min(...Object.values(data.value)));
const maxDataValue = computed(() => Math.max(...Object.values(data.value)));

const chartLabels = getChartLabels(props.indicator);

const setColoredBarsWidth = () => {
  for (let index = 0; index < Object.values(sortedData.value).length; index++) {
    const coloredBarWidth = calculateBarWidth(minDataValue.value, maxDataValue.value, Object.values(sortedData.value)[index]);
    const coloredBar = document.querySelector(`#report-${props.indicator}_bar_${index}`);
    if (coloredBar) {
      coloredBar.style.width = coloredBarWidth;
    }
  }
};

onMounted(() => {
  setColoredBarsWidth();
});

</script>

<style lang="scss" scoped>
@use './report-horizontal-bar-chart-component-stylesheet.scss';
</style>